# apps/permissions/serializers.py
from rest_framework import serializers
from apps.permissions.models import Permission
from apps.knowledge_base.models import KnowledgeBase
from apps.accounts.models import User

class PermissionSerializer(serializers.ModelSerializer):
    knowledge_base = serializers.PrimaryKeyRelatedField(queryset=KnowledgeBase.objects.all())
    applicant = serializers.PrimaryKeyRelatedField(queryset=User.objects.all(), required=False)
    approver = serializers.PrimaryKeyRelatedField(queryset=User.objects.all(), allow_null=True, required=False)

    class Meta:
        model = Permission
        fields = [
            'id', 'knowledge_base', 'applicant', 'approver', 'permissions',
            'status', 'created_at', 'expires_at', 'response_message'
        ]
        read_only_fields = ['id', 'created_at', 'applicant', 'approver', 'status', 'response_message']